diff --git a/core/src/aos_main.cpp b/core/src/aos_main.cpp
index 9fb60dd..654be93 100644
--- a/core/src/aos_main.cpp
+++ b/core/src/aos_main.cpp
@@ -1,6 +1,6 @@
 /*
 AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
-Copyright (C) 2016..2018  Thomas Schöpping et al.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -61,7 +61,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define DELAYEVENT_MASK                         EVENT_MASK(4)
 
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
 
 /**
  * @brief   CAN message identifier for initialization of the SSSP stack initialization sequence.
@@ -78,7 +78,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define SSSP_STACKINIT_CANMSGID_ABORT           0x001
 
-#endif
+#else /* AMIROOS_CFG_SSSP_ENABLE == false */
+
+/**
+ * @brief   Default shutdown mode if SSSP is unavailable.
+ */
+#define AOS_SHUTDOWN_DEFAULT                    AOS_SHUTDOWN_DEEPSLEEP
+
+#endif /* AMIROOS_CFG_SSSP_ENABLE */
 
 /**
  * @brief   CAN message identifier for calender synchronization message.
@@ -106,8 +113,8 @@ static AosIOChannel _stdiochannel;
  * @brief   I/O shell channel for the programmer interface.
  */
 static AosShellChannel _stdshellchannel;
-#endif
-#endif
+#endif /* AMIROOS_CFG_SHELL_ENABLE == true */
+#endif /* defined(MODULE_HAL_PROGIF) */
 
 /*
  * hook to add further static variables
@@ -125,16 +132,15 @@ AMIROOS_CFG_MAIN_EXTRA_STATIC_VARIABLES
 static inline void _unexpectedEventError(const eventmask_t mask, const eventflags_t flags)
 {
 #if (AMIROOS_CFG_DBG == true)
-    aosprintf("CTRL: unexpected/unknown event received. mask: 0x%08X; flags: 0x%08X\n", mask, flags);
+  aosprintf("CTRL: unexpected/unknown event received. mask: 0x%08X; flags: 0x%08X\n", mask, flags);
 #else
-    (void)(mask);
-    (void)(flags);
+  (void)(mask);
+  (void)(flags);
 #endif
-    return;
+  return;
 }
 
-
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Callback function to be used during SSSP stack initialization sequence.
  *
@@ -142,15 +148,16 @@ static inline void _unexpectedEventError(const eventmask_t mask, const eventflag
  */
 static void _ssspTimerCallback(void* par)
 {
-    aosDbgCheck(par != NULL);
+  aosDbgCheck(par != NULL);
 
-    chSysLockFromISR();
-    chEvtBroadcastI((event_source_t*)par);
-    chSysUnlockFromISR();
+  chSysLockFromISR();
+  chEvtBroadcastI((event_source_t*)par);
+  chSysUnlockFromISR();
 
-    return;
+  return;
 }
-#endif
+#endif /* AMIROOS_CFG_SSSP_ENABLE == true */
+
 /**
  * @brief   Helper function to serialize data.
  *
@@ -160,14 +167,14 @@ static void _ssspTimerCallback(void* par)
  */
 inline void _serialize(uint8_t* dst, const uint64_t src, const uint8_t n)
 {
-    aosDbgCheck(dst != NULL);
-    aosDbgCheck(n > 0 && n <= 8);
+  aosDbgCheck(dst != NULL);
+  aosDbgCheck(n > 0 && n <= 8);
 
-    for (uint8_t byte = 0; byte < n; ++byte) {
-        dst[byte] = (uint8_t)((src >> (byte * 8)) & 0xFF);
-    }
+  for (uint8_t byte = 0; byte < n; ++byte) {
+    dst[byte] = (uint8_t)((src >> (byte * 8)) & 0xFF);
+  }
 
-    return;
+  return;
 }
 
 /**
@@ -180,15 +187,15 @@ inline void _serialize(uint8_t* dst, const uint64_t src, const uint8_t n)
  */
 inline uint64_t _deserialize(uint8_t* src, const uint8_t n)
 {
-    aosDbgCheck(src != NULL);
-    aosDbgCheck(n > 0 && n <= 8);
+  aosDbgCheck(src != NULL);
+  aosDbgCheck(n > 0 && n <= 8);
 
-    uint64_t result = 0;
-    for (uint8_t byte = 0; byte < n; ++byte) {
-        result |= ((uint64_t)src[byte]) << (byte * 8);
-    }
+  uint64_t result = 0;
+  for (uint8_t byte = 0; byte < n; ++byte) {
+    result |= ((uint64_t)src[byte]) << (byte * 8);
+  }
 
-    return result;
+  return result;
 }
 
 /**
@@ -210,17 +217,17 @@ inline uint64_t _deserialize(uint8_t* src, const uint8_t n)
  */
 inline uint64_t _TM2U64(struct tm* src)
 {
-    aosDbgCheck(src != NULL);
-
-    return (((uint64_t)(src->tm_sec  & 0x0000003F) << (0))               |
-            ((uint64_t)(src->tm_min  & 0x0000003F) << (6))               |
-            ((uint64_t)(src->tm_hour & 0x0000001F) << (12))              |
-            ((uint64_t)(src->tm_mday & 0x0000001F) << (17))              |
-            ((uint64_t)(src->tm_mon  & 0x0000000F) << (22))              |
-            ((uint64_t)(src->tm_year & 0x00FFFFFF) << (26))              |
-            ((uint64_t)(src->tm_wday & 0x00000007) << (50))              |
-            ((uint64_t)(src->tm_yday & 0x000001FF) << (53))              |
-            ((uint64_t)((src->tm_isdst == 0) ? 0 : (src->tm_isdst > 0) ? 1 : 2) << (62)));
+  aosDbgCheck(src != NULL);
+
+  return (((uint64_t)(src->tm_sec  & 0x0000003F) << (0))               |
+          ((uint64_t)(src->tm_min  & 0x0000003F) << (6))               |
+          ((uint64_t)(src->tm_hour & 0x0000001F) << (12))              |
+          ((uint64_t)(src->tm_mday & 0x0000001F) << (17))              |
+          ((uint64_t)(src->tm_mon  & 0x0000000F) << (22))              |
+          ((uint64_t)(src->tm_year & 0x00FFFFFF) << (26))              |
+          ((uint64_t)(src->tm_wday & 0x00000007) << (50))              |
+          ((uint64_t)(src->tm_yday & 0x000001FF) << (53))              |
+          ((uint64_t)((src->tm_isdst == 0) ? 0 : (src->tm_isdst > 0) ? 1 : 2) << (62)));
 }
 
 /**
@@ -233,21 +240,22 @@ inline uint64_t _TM2U64(struct tm* src)
  */
 inline void _U642TM(struct tm* dst, const uint64_t src)
 {
-    aosDbgCheck(dst != NULL);
-
-    dst->tm_sec  = (src >> 0)  & 0x0000003F;
-    dst->tm_min  = (src >> 6)  & 0x0000003F;
-    dst->tm_hour = (src >> 12) & 0x0000001F;
-    dst->tm_mday = (src >> 17) & 0x0000001F;
-    dst->tm_mon  = (src >> 22) & 0x0000000F;
-    dst->tm_year = (src >> 26) & 0x00FFFFFF;
-    dst->tm_wday = (src >> 50) & 0x00000007;
-    dst->tm_yday = (src >> 53) & 0x000001FF;
-    dst->tm_isdst = (((src >> 62) & 0x03) == 0) ? 0 : (((src >> 62) & 0x03) > 0) ? 1 : -1;
-
-    return;
+  aosDbgCheck(dst != NULL);
+
+  dst->tm_sec  = (src >> 0)  & 0x0000003F;
+  dst->tm_min  = (src >> 6)  & 0x0000003F;
+  dst->tm_hour = (src >> 12) & 0x0000001F;
+  dst->tm_mday = (src >> 17) & 0x0000001F;
+  dst->tm_mon  = (src >> 22) & 0x0000000F;
+  dst->tm_year = (src >> 26) & 0x00FFFFFF;
+  dst->tm_wday = (src >> 50) & 0x00000007;
+  dst->tm_yday = (src >> 53) & 0x000001FF;
+  dst->tm_isdst = (((src >> 62) & 0x03) == 0) ? 0 : (((src >> 62) & 0x03) > 0) ? 1 : -1;
+
+  return;
 }
-#if (AMIROOS_CFG_SSSP_ENABLE == true)
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Implementation of the SSSP module stack initialization sequence (startup phase 3).
  *
@@ -257,67 +265,68 @@ inline void _U642TM(struct tm* dst, const uint64_t src)
  */
 aos_shutdown_t _ssspModuleStackInitialization(void)
 {
-    // local types
-    /**
+  // local types
+  /**
    * @brief   States for the internal state machine to implement SSSP startup stage 3.
    */
-    typedef enum {
-        STAGE_3_1,                  /**< Initiation of SSSP startup stage 3. */
-        STAGE_3_2,                  /**< Starting the sequence and broadcasting the first ID. */
-        STAGE_3_3_WAITFORFIRSTID,   /**< Waiting for first ID after initiation. */
-        STAGE_3_3_WAITFORIDORSIG,   /**< Waiting for next ID or activation of neighbor signal. */
-        STAGE_3_3_WAITFORID,        /**< Waiting for next ID (after the module has set its own ID). */
-        STAGE_3_4_FINISH,           /**< Successful finish of stage 3. */
-        STAGE_3_4_ABORT_ACTIVE,     /**< Aborting stage 3 (active). */
-        STAGE_3_4_ABORT,            /**< Aborting stage 3 (passive). */
-    } sssp_modulestackinitstage_t;
-
-    typedef struct {
-        bool loop     : 1;
-        bool wfe      : 1;
-        bool wfe_next : 1;
-    } flags_t;
-
-    // local variables
-    aos_shutdown_t shutdown = AOS_SHUTDOWN_NONE;
-    sssp_modulestackinitstage_t stage = STAGE_3_1;
-    eventmask_t eventmask = 0;
-    eventflags_t ioflags;
-    event_source_t eventSourceTimeout;
-    event_source_t eventSourceDelay;
-    event_listener_t eventListenerTimeout;
-    event_listener_t eventListenerDelay;
-    event_listener_t eventListenerCan;
-    virtual_timer_t timerTimeout;
-    virtual_timer_t timerDelay;
-    CANTxFrame canTxFrame;
-    CANRxFrame canRxFrame;
+  typedef enum {
+    STAGE_3_1,                  /**< Initiation of SSSP startup stage 3. */
+    STAGE_3_2,                  /**< Starting the sequence and broadcasting the first ID. */
+    STAGE_3_3_WAITFORFIRSTID,   /**< Waiting for first ID after initiation. */
+    STAGE_3_3_WAITFORIDORSIG,   /**< Waiting for next ID or activation of neighbor signal. */
+    STAGE_3_3_WAITFORID,        /**< Waiting for next ID (after the module has set its own ID). */
+    STAGE_3_4_FINISH,           /**< Successful finish of stage 3. */
+    STAGE_3_4_ABORT_ACTIVE,     /**< Aborting stage 3 (active). */
+    STAGE_3_4_ABORT,            /**< Aborting stage 3 (passive). */
+  } sssp_modulestackinitstage_t;
+
+  typedef struct {
+    bool loop     : 1;
+    bool wfe      : 1;
+    bool wfe_next : 1;
+  } flags_t;
+
+  // local variables
+  aos_shutdown_t shutdown = AOS_SHUTDOWN_NONE;
+  sssp_modulestackinitstage_t stage = STAGE_3_1;
+  eventmask_t eventmask = 0;
+  eventflags_t ioflags = 0;
+  event_source_t eventSourceTimeout;
+  event_source_t eventSourceDelay;
+  event_listener_t eventListenerTimeout;
+  event_listener_t eventListenerDelay;
+  event_listener_t eventListenerCan;
+  virtual_timer_t timerTimeout;
+  virtual_timer_t timerDelay;
+  CANTxFrame canTxFrame;
+  CANRxFrame canRxFrame;
 #if (AMIROOS_CFG_SSSP_STACK_START != true) || (AMIROOS_CFG_DBG == true)
-    aos_ssspmoduleid_t lastid = 0;
-#endif
-    flags_t flags;
-
-    // initialize local varibles
-    chEvtObjectInit(&eventSourceTimeout);
-    chEvtObjectInit(&eventSourceDelay);
-    chVTObjectInit(&timerTimeout);
-    chVTObjectInit(&timerDelay);
-    canTxFrame.RTR = CAN_RTR_DATA;
-    canTxFrame.IDE = CAN_IDE_STD;
-    flags.loop = true;
-    flags.wfe = false; // do not wait for events in the initial iteration of the FSM loop
-    flags.wfe_next = true;
-
-    // initialize system variables
-    aos.sssp.stage = AOS_SSSP_STARTUP_3_1;
-    aos.sssp.moduleId = 0;
-
-    // listen to events (timout, delay, CAN receive)
-    chEvtRegisterMask(&eventSourceTimeout, &eventListenerTimeout, TIMEOUTEVENT_MASK);
-    chEvtRegisterMask(&eventSourceDelay, &eventListenerDelay, DELAYEVENT_MASK);
-    chEvtRegisterMask(&MODULE_HAL_CAN.rxfull_event, &eventListenerCan, CANEVENT_MASK);
-
-    /*
+  aos_ssspmoduleid_t lastid = 0;
+#endif
+  flags_t flags;
+  aos_timestamp_t uptime;
+
+  // initialize local varibles
+  chEvtObjectInit(&eventSourceTimeout);
+  chEvtObjectInit(&eventSourceDelay);
+  chVTObjectInit(&timerTimeout);
+  chVTObjectInit(&timerDelay);
+  canTxFrame.RTR = CAN_RTR_DATA;
+  canTxFrame.IDE = CAN_IDE_STD;
+  flags.loop = true;
+  flags.wfe = false; // do not wait for events in the initial iteration of the FSM loop
+  flags.wfe_next = true;
+
+  // initialize system variables
+  aos.sssp.stage = AOS_SSSP_STARTUP_3_1;
+  aos.sssp.moduleId = 0;
+
+  // listen to events (timout, delay, CAN receive)
+  chEvtRegisterMask(&eventSourceTimeout, &eventListenerTimeout, TIMEOUTEVENT_MASK);
+  chEvtRegisterMask(&eventSourceDelay, &eventListenerDelay, DELAYEVENT_MASK);
+  chEvtRegisterMask(&MODULE_HAL_CAN.rxfull_event, &eventListenerCan, CANEVENT_MASK);
+
+  /*
    * FSM in a loop.
    *
    * This is a fully event-based FSM for the module stack initialization
